#include<bits/stdc++.h>
using namespace std;

int height[2000000];
long long br;

void func(int l,int r){
    if(l>=r-1)return;
    int maxi=1;
    for(int i=l+1;i<=r;i++){
        if(height[i]>height[maxi])maxi=i;
    }
    br-=(maxi-l)*(r-maxi);
    func(l,maxi-1);
    func(maxi+1,r);
}

int main(){
    int n;
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>height[i];
    }
    br=n*(n-1);
    func(0,n-1);
    cout<<br<<endl;
    return 0;
}
